/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: target_config.c 2183 2011-07-23 10:29:36Z ertl-honda $
 */

/*
 * ^[QbgˑW[iCY8C5XLPpj
 */
#include "kernel_impl.h"
#include <sil.h>
#include "t_stddef.h"

#include "device.h"

#ifndef CYINT_VECT_TABLE
#define CYINT_VECT_TABLE    ((cyisraddress **) CYREG_NVIC_VECT_OFFSET)
#endif /* CYINT_VECT_TABLE */

extern void target_usart_init();
extern const FP _kernel_vector_table[];

/*
 *  ^[Qbgˑ̏
 */
void
target_initialize(void){
    uint32 i;
    cyisraddress *ramVectorTable;

	/*
	 * RAM̃xN^e[uAhXۑ
	 */
    ramVectorTable = (cyisraddress *) *CYINT_VECT_TABLE;

	/*
	 * RAˑ̏
	 */
	core_initialize();

    /*
	 * xN^AhXNVIC֍Đݒ
	 */
    *CYINT_VECT_TABLE = ramVectorTable;
    for(i = 0; i < 48 ; i++)
    {
        *ramVectorTable++ = (cyisraddress)_kernel_vector_table[i];
    }

	/*
	 *  target_fput_log \ɂȂ悤UART
	 */
	target_usart_init((ID) 0);

} 


/*
 *  ^[Qbgˑ̏I
 */
void
target_exit(void)
{
	/*
	 *  RAˑ̏I
	 */
	core_terminate();

	/*
	 *  Jˑ̏I
	 */
	while(1);
}


/*
 *  VXeO̒჌xo͂̂߂̕o
 */
void
target_fput_log(char c)
{
	if (c == '\n') {
		UART_1_PutChar((uint8) '\r');
	}
	UART_1_PutChar((uint8) c);
}
