/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: target_serial.c 2202 2011-07-26 13:27:11Z ertl-honda $
 */

/*
 *  VAI/OfoCXiSIOjhCoiCY8C5XLPpj
 */

#include <kernel.h>
#include <t_syslog.h>
#include "target_serial.h"
#include "core_insn.h"
#include "cyfitter.h"
#include "UART_1.h"
#if (TNUM_SIOP >= 2)
	#include "UART_2.h"
#endif /* TNUM_SIOP >= 2 */
#if (TNUM_SIOP >= 3)
	#include "UART_3.h"
#endif /* TNUM_SIOP >= 3 */
#if (TNUM_SIOP >= 4)
	#include "UART_4.h"
#endif /* TNUM_SIOP >= 4 */
#if(UART_1_INTERNAL_CLOCK_USED)
    #include "UART_1_IntClock.h"
#endif /* End UART_1_INTERNAL_CLOCK_USED */
#if(UART_2_INTERNAL_CLOCK_USED)
    #include "UART_2_IntClock.h"
#endif /* End UART_2_INTERNAL_CLOCK_USED */
#if(UART_3_INTERNAL_CLOCK_USED)
    #include "UART_3_IntClock.h"
#endif /* End UART_3_INTERNAL_CLOCK_USED */
#if(UART_4_INTERNAL_CLOCK_USED)
    #include "UART_4_IntClock.h"
#endif /* End UART_4_INTERNAL_CLOCK_USED */

/*
 *  VAI/O|[gubN̒`
 */
typedef struct sio_port_initialization_block {
	ID       port;   /* SIÕ|[gID(_ԍ) */
	INTNO    intno;  /* ݔԍ */
} SIOPINIB;

/*
 *  VAI/O|[gǗubN̒`
 */
struct sio_port_control_block {
	const SIOPINIB  *p_siopinib;  /* VAI/O|[gubN */
	intptr_t        exinf;        /* g */
	bool_t          opnflg;       /* I[vς݃tO */
};

/*
 * VAI/O|[gubN
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
	{(ID)0, (INTNO)INTNO_SIO1},
#if (TNUM_SIOP >= 2)
	{(ID)1, (INTNO)INTNO_SIO2},
#endif /* TNUM_SIOP >= 2 */
#if (TNUM_SIOP >= 3)
	{(ID)2, (INTNO)INTNO_SIO3},
#endif /* TNUM_SIOP >= 3 */
#if (TNUM_SIOP >= 4)
	{(ID)3, (INTNO)INTNO_SIO4},
#endif /* TNUM_SIOP >= 4 */
};

/*
 *  VAI/O|[gǗubÑGA
 */
SIOPCB	siopcb_table[TNUM_SIOP];

/*
 *  VAI/O|[gIDǗubNo߂̃}N
 */
#define INDEX_SIOP(siopid)	((uint_t)((siopid) - 1))
#define get_siopcb(siopid)	(&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 *  ^[Qbg̃VA
 *
 * PSoC CreatorUARThCoQlɍ쐬
 *
 * EUART_*_TXCLKGENDPV{̒`ŝ߂̂܂܈p
 * EUART_1_INTERNAL_CLOCK_USEDV{̓[UI\Ƃ
 */
void target_usart_init(ID siopid)
{
	switch(siopid) {
	case 0:	/* VA|[gID:0 */
		if((UART_1_RXBITCTR_CONTROL_REG && UART_1_CNTR_ENABLE) == 0) {
	        /* Init Count7 period */
	        UART_1_RXBITCTR_PERIOD_REG = UART_1_RXBITCTR_INIT;
	        /* Configure the Initial RX interrupt mask */
	        UART_1_RXSTATUS_MASK_REG  = UART_1_INIT_RX_INTERRUPTS_MASK;
	
	        /* Write Counter Value for TX Bit Clk Generator*/
	        #if(UART_1_TXCLKGEN_DP)
	            UART_1_TXBITCLKGEN_CTR_REG = UART_1_BIT_CENTER;
	            UART_1_TXBITCLKTX_COMPLETE_REG = (UART_1_NUMBER_OF_DATA_BITS +
	                        UART_1_NUMBER_OF_START_BIT) * UART_1_OVER_SAMPLE_COUNT;
	        #else
	            UART_1_TXBITCTR_PERIOD_REG = ((UART_1_NUMBER_OF_DATA_BITS +
	                        UART_1_NUMBER_OF_START_BIT) * UART_1_OVER_SAMPLE_8) - 1u;
	        #endif /* End UART_1_TXCLKGEN_DP */

	        /* Configure the Initial TX interrupt mask */
	        #if(UART_1_TX_INTERRUPT_ENABLED && (UART_1_TXBUFFERSIZE > UART_1_FIFO_LENGTH))
	            UART_1_TXSTATUS_MASK_REG = UART_1_TX_STS_FIFO_EMPTY;
	        #else
	            UART_1_TXSTATUS_MASK_REG = UART_1_INIT_TX_INTERRUPTS_MASK;
	        #endif /*End UART_1_TX_INTERRUPT_ENABLED*/

	        /*RX Counter (Count7) Enable */
	        UART_1_RXBITCTR_CONTROL_REG |= UART_1_CNTR_ENABLE;
	        /* Enable the RX Interrupt. */
/*	        UART_1_RXSTATUS_ACTL_REG  |= UART_1_INT_ENABLE;*/

	        /*TX Counter (DP/Count7) Enable */
	        #if(!UART_1_TXCLKGEN_DP)
	            UART_1_TXBITCTR_CONTROL_REG |= UART_1_CNTR_ENABLE;
	        #endif /* End UART_1_TXCLKGEN_DP */
	        /* Enable the TX Interrupt. */
/*	        UART_1_TXSTATUS_ACTL_REG |= UART_1_INT_ENABLE;*/

		    #if(UART_1_INTERNAL_CLOCK_USED)
	    	   /* Enable the clock. */
		        UART_1_IntClock_Start();
		    #endif /* End UART_1_INTERNAL_CLOCK_USED */
		}
		break;
#if (TNUM_SIOP >= 2)
	case 1:	/* VA|[gID:1 */
		if((UART_2_RXBITCTR_CONTROL_REG && UART_2_CNTR_ENABLE) == 0) {
	        /* Init Count7 period */
	        UART_2_RXBITCTR_PERIOD_REG = UART_2_RXBITCTR_INIT;
	        /* Configure the Initial RX interrupt mask */
	        UART_2_RXSTATUS_MASK_REG  = UART_2_INIT_RX_INTERRUPTS_MASK;
	
	        /* Write Counter Value for TX Bit Clk Generator*/
	        #if(UART_2_TXCLKGEN_DP)
	            UART_2_TXBITCLKGEN_CTR_REG = UART_2_BIT_CENTER;
	            UART_2_TXBITCLKTX_COMPLETE_REG = (UART_2_NUMBER_OF_DATA_BITS +
	                        UART_2_NUMBER_OF_START_BIT) * UART_2_OVER_SAMPLE_COUNT;
	        #else
	            UART_2_TXBITCTR_PERIOD_REG = ((UART_2_NUMBER_OF_DATA_BITS +
	                        UART_2_NUMBER_OF_START_BIT) * UART_2_OVER_SAMPLE_8) - 1u;
	        #endif /* End UART_2_TXCLKGEN_DP */

	        /* Configure the Initial TX interrupt mask */
	        #if(UART_2_TX_INTERRUPT_ENABLED && (UART_2_TXBUFFERSIZE > UART_2_FIFO_LENGTH))
	            UART_2_TXSTATUS_MASK_REG = UART_2_TX_STS_FIFO_EMPTY;
	        #else
	            UART_2_TXSTATUS_MASK_REG = UART_2_INIT_TX_INTERRUPTS_MASK;
	        #endif /*End UART_2_TX_INTERRUPT_ENABLED*/

	        /*RX Counter (Count7) Enable */
	        UART_2_RXBITCTR_CONTROL_REG |= UART_2_CNTR_ENABLE;
	        /* Enable the RX Interrupt. */
/*	        UART_2_RXSTATUS_ACTL_REG  |= UART_2_INT_ENABLE;*/

	        /*TX Counter (DP/Count7) Enable */
	        #if(!UART_2_TXCLKGEN_DP)
	            UART_2_TXBITCTR_CONTROL_REG |= UART_2_CNTR_ENABLE;
	        #endif /* End UART_2_TXCLKGEN_DP */
	        /* Enable the TX Interrupt. */
/*	        UART_2_TXSTATUS_ACTL_REG |= UART_2_INT_ENABLE;*/

		    #if(UART_2_INTERNAL_CLOCK_USED)
	    	   /* Enable the clock. */
		        UART_2_IntClock_Start();
		    #endif /* End UART_2_INTERNAL_CLOCK_USED */
		}
		break;
#endif /* TNUM_SIOP >= 2 */
#if (TNUM_SIOP >= 3)
	case 2:	/* VA|[gID:2 */
		if((UART_3_RXBITCTR_CONTROL_REG && UART_3_CNTR_ENABLE) == 0) {
	        /* Init Count7 period */
	        UART_3_RXBITCTR_PERIOD_REG = UART_3_RXBITCTR_INIT;
	        /* Configure the Initial RX interrupt mask */
	        UART_3_RXSTATUS_MASK_REG  = UART_3_INIT_RX_INTERRUPTS_MASK;
	
	        /* Write Counter Value for TX Bit Clk Generator*/
	        #if(UART_3_TXCLKGEN_DP)
	            UART_3_TXBITCLKGEN_CTR_REG = UART_3_BIT_CENTER;
	            UART_3_TXBITCLKTX_COMPLETE_REG = (UART_3_NUMBER_OF_DATA_BITS +
	                        UART_3_NUMBER_OF_START_BIT) * UART_3_OVER_SAMPLE_COUNT;
	        #else
	            UART_3_TXBITCTR_PERIOD_REG = ((UART_3_NUMBER_OF_DATA_BITS +
	                        UART_3_NUMBER_OF_START_BIT) * UART_3_OVER_SAMPLE_8) - 1u;
	        #endif /* End UART_3_TXCLKGEN_DP */

	        /* Configure the Initial TX interrupt mask */
	        #if(UART_3_TX_INTERRUPT_ENABLED && (UART_3_TXBUFFERSIZE > UART_3_FIFO_LENGTH))
	            UART_3_TXSTATUS_MASK_REG = UART_3_TX_STS_FIFO_EMPTY;
	        #else
	            UART_3_TXSTATUS_MASK_REG = UART_3_INIT_TX_INTERRUPTS_MASK;
	        #endif /*End UART_3_TX_INTERRUPT_ENABLED*/

	        /*RX Counter (Count7) Enable */
	        UART_3_RXBITCTR_CONTROL_REG |= UART_3_CNTR_ENABLE;
	        /* Enable the RX Interrupt. */
/*	        UART_3_RXSTATUS_ACTL_REG  |= UART_3_INT_ENABLE;*/

	        /*TX Counter (DP/Count7) Enable */
	        #if(!UART_3_TXCLKGEN_DP)
	            UART_3_TXBITCTR_CONTROL_REG |= UART_3_CNTR_ENABLE;
	        #endif /* End UART_3_TXCLKGEN_DP */
	        /* Enable the TX Interrupt. */
/*	        UART_3_TXSTATUS_ACTL_REG |= UART_3_INT_ENABLE;*/

		    #if(UART_3_INTERNAL_CLOCK_USED)
	    	   /* Enable the clock. */
		        UART_3_IntClock_Start();
		    #endif /* End UART_3_INTERNAL_CLOCK_USED */
		}
		break;
#endif /* TNUM_SIOP >= 3 */
#if (TNUM_SIOP >= 4)
	case 3:	/* VA|[gID:3 */
		if((UART_4_RXBITCTR_CONTROL_REG && UART_4_CNTR_ENABLE) == 0) {
	        /* Init Count7 period */
	        UART_4_RXBITCTR_PERIOD_REG = UART_4_RXBITCTR_INIT;
	        /* Configure the Initial RX interrupt mask */
	        UART_4_RXSTATUS_MASK_REG  = UART_4_INIT_RX_INTERRUPTS_MASK;
	
	        /* Write Counter Value for TX Bit Clk Generator*/
	        #if(UART_4_TXCLKGEN_DP)
	            UART_4_TXBITCLKGEN_CTR_REG = UART_4_BIT_CENTER;
	            UART_4_TXBITCLKTX_COMPLETE_REG = (UART_4_NUMBER_OF_DATA_BITS +
	                        UART_4_NUMBER_OF_START_BIT) * UART_4_OVER_SAMPLE_COUNT;
	        #else
	            UART_4_TXBITCTR_PERIOD_REG = ((UART_4_NUMBER_OF_DATA_BITS +
	                        UART_4_NUMBER_OF_START_BIT) * UART_4_OVER_SAMPLE_8) - 1u;
	        #endif /* End UART_4_TXCLKGEN_DP */

	        /* Configure the Initial TX interrupt mask */
	        #if(UART_4_TX_INTERRUPT_ENABLED && (UART_4_TXBUFFERSIZE > UART_4_FIFO_LENGTH))
	            UART_4_TXSTATUS_MASK_REG = UART_4_TX_STS_FIFO_EMPTY;
	        #else
	            UART_4_TXSTATUS_MASK_REG = UART_4_INIT_TX_INTERRUPTS_MASK;
	        #endif /*End UART_4_TX_INTERRUPT_ENABLED*/

	        /*RX Counter (Count7) Enable */
	        UART_4_RXBITCTR_CONTROL_REG |= UART_4_CNTR_ENABLE;
	        /* Enable the RX Interrupt. */
/*	        UART_4_RXSTATUS_ACTL_REG  |= UART_4_INT_ENABLE;*/

	        /*TX Counter (DP/Count7) Enable */
	        #if(!UART_4_TXCLKGEN_DP)
	            UART_4_TXBITCTR_CONTROL_REG |= UART_4_CNTR_ENABLE;
	        #endif /* End UART_4_TXCLKGEN_DP */
	        /* Enable the TX Interrupt. */
/*	        UART_4_TXSTATUS_ACTL_REG |= UART_4_INT_ENABLE;*/

		    #if(UART_4_INTERNAL_CLOCK_USED)
	    	   /* Enable the clock. */
		        UART_4_IntClock_Start();
		    #endif /* End UART_4_INTERNAL_CLOCK_USED */
		}
		break;
#endif /* TNUM_SIOP >= 4 */
	default: /* `|[g */
		break;
	};
}

/*
 *  SIOhCȍ
 */
void
sio_initialize(intptr_t exinf)
{
	SIOPCB	*p_siopcb;
	uint_t	i;

	/*
	 *  VAI/O|[gǗubN̏
	 */
	for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
		p_siopcb->p_siopinib = &(siopinib_table[i]);
		p_siopcb->opnflg = false;
	}
}


/*
 *  VAI/O|[g̃I[v
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB          *p_siopcb;
	const SIOPINIB  *p_siopinib;
	bool_t  opnflg;
	ER      ercd;

	p_siopcb = get_siopcb(siopid);
	p_siopinib = p_siopcb->p_siopinib;

	/*
	 *  I[v|[g邩opnflgɓǂłD
	 */
	opnflg = p_siopcb->opnflg;

	p_siopcb->exinf = exinf;

	/*
	 *  n[hEFȀ
	 */
	target_usart_init(siopid);

	/*
	 *  VAI/Õ݂}XND
	 */
	if (!opnflg) {
		ercd = ena_int(p_siopinib->intno);
		assert(ercd == E_OK);
	}

	return(p_siopcb);
}

/*
 *  VAI/O|[g̃N[Y
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
	/*
	 *  VAI/O݂}XND
	 */
	if (!(p_siopcb->opnflg)) {
		dis_int(p_siopcb->p_siopinib->intno);
	}
}

/*
 *  SIO̊݃T[rX[`
 */
void
sio_isr(intptr_t exinf)
{
	SIOPCB          *p_siopcb;

	p_siopcb = get_siopcb(exinf);

	/*
	 *  ݂̃NA
	 */
/* PSoC UARTłKvvmF */

/* VA|[g؂ւꍇ́Cp_siopcb->p_siopinib->ID Ŕʂ*/

	ID siopid = p_siopcb->p_siopinib->port;

	switch(siopid) {
	case 0:	/* VA|[gID:0 */
		if ((UART_1_ReadRxStatus() & UART_1_RX_STS_FIFO_NOTEMPTY) != 0u) {
			/*
			 *  MʒmR[obN[`ĂяoD
			 */
			sio_irdy_rcv(p_siopcb->exinf);
		}
		if ((UART_1_ReadTxStatus() & UART_1_TX_STS_FIFO_FULL) == 0u) {
			/*
			 *  M\R[obN[`ĂяoD
			 */
			sio_irdy_snd(p_siopcb->exinf);
		}
		break;
#if (TNUM_SIOP >= 2)
	case 1:	/* VA|[gID:1 */
		if ((UART_2_ReadRxStatus() & UART_2_RX_STS_FIFO_NOTEMPTY) != 0u) {
			/*
			 *  MʒmR[obN[`ĂяoD
			 */
			sio_irdy_rcv(p_siopcb->exinf);
		}
		if ((UART_2_ReadTxStatus() & UART_2_TX_STS_FIFO_FULL) == 0u) {
			/*
			 *  M\R[obN[`ĂяoD
			 */
			sio_irdy_snd(p_siopcb->exinf);
		}
		break;
#endif /* TNUM_SIOP >= 2 */
#if (TNUM_SIOP >= 3)
	case 2:	/* VA|[gID:2 */
		if ((UART_3_ReadRxStatus() & UART_3_RX_STS_FIFO_NOTEMPTY) != 0u) {
			/*
			 *  MʒmR[obN[`ĂяoD
			 */
			sio_irdy_rcv(p_siopcb->exinf);
		}
		if ((UART_3_ReadTxStatus() & UART_3_TX_STS_FIFO_FULL) == 0u) {
			/*
			 *  M\R[obN[`ĂяoD
			 */
			sio_irdy_snd(p_siopcb->exinf);
		}
		break;
#endif /* TNUM_SIOP >= 3 */
#if (TNUM_SIOP >= 4)
	case 3:	/* VA|[gID:3 */
		if ((UART_4_ReadRxStatus() & UART_4_RX_STS_FIFO_NOTEMPTY) != 0u) {
			/*
			 *  MʒmR[obN[`ĂяoD
			 */
			sio_irdy_rcv(p_siopcb->exinf);
		}
		if ((UART_4_ReadTxStatus() & UART_4_TX_STS_FIFO_FULL) == 0u) {
			/*
			 *  M\R[obN[`ĂяoD
			 */
			sio_irdy_snd(p_siopcb->exinf);
		}
		break;
#endif /* TNUM_SIOP >= 4 */
	default: /* `|[g */
		break;
	};
}

/*
 *  VAI/O|[gւ̕M
 */
bool_t
sio_snd_chr(SIOPCB *p_siopcb, char c)
{
/* VA|[g؂ւꍇ́Cp_siopcb->p_siopinib->ID Ŕʂ*/

	ID siopid = p_siopcb->p_siopinib->port;

	switch(siopid) {
	case 0:	/* VA|[gID:0 */
		if((UART_1_ReadTxStatus() & UART_1_TX_STS_FIFO_FULL) == 0u){
	        UART_1_TXDATA_REG = (uint8)c;
			return(true);
		}
		break;
#if (TNUM_SIOP >= 2)
	case 1:	/* VA|[gID:1 */
		if((UART_2_ReadTxStatus() & UART_2_TX_STS_FIFO_FULL) == 0u){
	        UART_2_TXDATA_REG = (uint8)c;
			return(true);
		}
		break;
#endif /* TNUM_SIOP >= 2 */
#if (TNUM_SIOP >= 3)
	case 2:	/* VA|[gID:2 */
		if((UART_3_ReadTxStatus() & UART_3_TX_STS_FIFO_FULL) == 0u){
	        UART_3_TXDATA_REG = (uint8)c;
			return(true);
		}
		break;
#endif /* TNUM_SIOP >= 3 */
#if (TNUM_SIOP >= 4)
	case 3:	/* VA|[gID:3 */
		if((UART_4_ReadTxStatus() & UART_4_TX_STS_FIFO_FULL) == 0u){
	        UART_4_TXDATA_REG = (uint8)c;
			return(true);
		}
		break;
#endif /* TNUM_SIOP >= 4 */
	default: /* `|[g */
		break;
	};
	return(false);
}

/*
 *  VAI/O|[g̕M
 */
int_t
sio_rcv_chr(SIOPCB *p_siopcb)
{
/* VA|[g؂ւꍇ́Cp_siopcb->p_siopinib->ID Ŕʂ*/

	ID siopid = p_siopcb->p_siopinib->port;

	switch(siopid) {
	case 0:	/* VA|[gID:0 */
		if((UART_1_ReadRxStatus() & UART_1_RX_STS_FIFO_NOTEMPTY) != 0u){
			return((int_t) UART_1_GetChar());
		}
		break;
#if (TNUM_SIOP >= 2)
	case 1:	/* VA|[gID:1 */
		if((UART_2_ReadRxStatus() & UART_2_RX_STS_FIFO_NOTEMPTY) != 0u){
			return((int_t) UART_2_GetChar());
		}
		break;
#endif /* TNUM_SIOP >= 2 */
#if (TNUM_SIOP >= 3)
	case 2:	/* VA|[gID:2 */
		if((UART_3_ReadRxStatus() & UART_3_RX_STS_FIFO_NOTEMPTY) != 0u){
			return((int_t) UART_3_GetChar());
		}
		break;
#endif /* TNUM_SIOP >= 3 */
#if (TNUM_SIOP >= 4)
	case 3:	/* VA|[gID:3 */
		if((UART_4_ReadRxStatus() & UART_4_RX_STS_FIFO_NOTEMPTY) != 0u){
			return((int_t) UART_4_GetChar());
		}
		break;
#endif /* TNUM_SIOP >= 4 */
	default: /* `|[g */
		break;
	};
	return(-1);
}

/*
 *  VAI/O|[g̃R[obN̋
 */
void
sio_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
/* VA|[g؂ւꍇ́Cp_siopcb->p_siopinib->ID Ŕʂ*/

	ID siopid = p_siopcb->p_siopinib->port;

	switch(siopid) {
	case 0:	/* VA|[gID:0 */
		switch (cbrtn) {
		  case SIO_RDY_SND:
	        /* Enable the TX Interrupt. */
	        UART_1_TXSTATUS_ACTL_REG |= UART_1_INT_ENABLE;
			break;
		  case SIO_RDY_RCV:
	        /* Enable the RX Interrupt. */
	        UART_1_RXSTATUS_ACTL_REG  |= UART_1_INT_ENABLE;
			break;
		}
		break;
#if (TNUM_SIOP >= 2)
	case 1:	/* VA|[gID:1 */
		switch (cbrtn) {
		  case SIO_RDY_SND:
	        /* Enable the TX Interrupt. */
	        UART_2_TXSTATUS_ACTL_REG |= UART_2_INT_ENABLE;
			break;
		  case SIO_RDY_RCV:
	        /* Enable the RX Interrupt. */
	        UART_2_RXSTATUS_ACTL_REG  |= UART_2_INT_ENABLE;
			break;
		}
		break;
#endif /* TNUM_SIOP >= 2 */
#if (TNUM_SIOP >= 3)
	case 2:	/* VA|[gID:2 */
		switch (cbrtn) {
		  case SIO_RDY_SND:
	        /* Enable the TX Interrupt. */
	        UART_3_TXSTATUS_ACTL_REG |= UART_3_INT_ENABLE;
			break;
		  case SIO_RDY_RCV:
	        /* Enable the RX Interrupt. */
	        UART_3_RXSTATUS_ACTL_REG  |= UART_3_INT_ENABLE;
			break;
		}
		break;
#endif /* TNUM_SIOP >= 3 */
#if (TNUM_SIOP >= 4)
	case 3:	/* VA|[gID:3 */
		switch (cbrtn) {
		  case SIO_RDY_SND:
	        /* Enable the TX Interrupt. */
	        UART_4_TXSTATUS_ACTL_REG |= UART_4_INT_ENABLE;
			break;
		  case SIO_RDY_RCV:
	        /* Enable the RX Interrupt. */
	        UART_4_RXSTATUS_ACTL_REG  |= UART_4_INT_ENABLE;
			break;
		}
		break;
#endif /* TNUM_SIOP >= 4 */
	default: /* `|[g */
		break;
	};
}

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
void
sio_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
/* VA|[g؂ւꍇ́Cp_siopcb->p_siopinib->ID Ŕʂ*/

	ID siopid = p_siopcb->p_siopinib->port;

	switch(siopid) {
	case 0:	/* VA|[gID:0 */
		switch (cbrtn) {
		  case SIO_RDY_SND:
	        /* Disable the TX Interrupt. */
	        UART_1_TXSTATUS_ACTL_REG &= (uint8)~UART_1_INT_ENABLE;
			break;
		  case SIO_RDY_RCV:
	        /* Disable the RX Interrupt. */
	        UART_1_RXSTATUS_ACTL_REG  &= (uint8)~UART_1_INT_ENABLE;
			break;
		}
		break;
#if (TNUM_SIOP >= 2)
	case 1:	/* VA|[gID:1 */
		switch (cbrtn) {
		  case SIO_RDY_SND:
	        /* Disable the TX Interrupt. */
	        UART_2_TXSTATUS_ACTL_REG &= (uint8)~UART_2_INT_ENABLE;
			break;
		  case SIO_RDY_RCV:
	        /* Disable the RX Interrupt. */
	        UART_2_RXSTATUS_ACTL_REG  &= (uint8)~UART_2_INT_ENABLE;
			break;
		}
		break;
#endif /* TNUM_SIOP >= 2 */
#if (TNUM_SIOP >= 3)
	case 2:	/* VA|[gID:2 */
		switch (cbrtn) {
		  case SIO_RDY_SND:
	        /* Disable the TX Interrupt. */
	        UART_3_TXSTATUS_ACTL_REG &= (uint8)~UART_3_INT_ENABLE;
			break;
		  case SIO_RDY_RCV:
	        /* Disable the RX Interrupt. */
	        UART_3_RXSTATUS_ACTL_REG  &= (uint8)~UART_3_INT_ENABLE;
			break;
		}
		break;
#endif /* TNUM_SIOP >= 3 */
#if (TNUM_SIOP >= 4)
	case 3:	/* VA|[gID:3 */
		switch (cbrtn) {
		  case SIO_RDY_SND:
	        /* Disable the TX Interrupt. */
	        UART_4_TXSTATUS_ACTL_REG &= (uint8)~UART_4_INT_ENABLE;
			break;
		  case SIO_RDY_RCV:
	        /* Disable the RX Interrupt. */
	        UART_4_RXSTATUS_ACTL_REG  &= (uint8)~UART_4_INT_ENABLE;
			break;
		}
		break;
#endif /* TNUM_SIOP >= 4 */
	default: /* `|[g */
		break;
	};
}
