/*******************************************************************************
* File Name: CAM_DATA.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_CAM_DATA_ALIASES_H) /* Pins CAM_DATA_ALIASES_H */
#define CY_PINS_CAM_DATA_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"


/***************************************
*              Constants        
***************************************/
#define CAM_DATA_0			(CAM_DATA__0__PC)
#define CAM_DATA_0_INTR	((uint16)((uint16)0x0001u << CAM_DATA__0__SHIFT))

#define CAM_DATA_1			(CAM_DATA__1__PC)
#define CAM_DATA_1_INTR	((uint16)((uint16)0x0001u << CAM_DATA__1__SHIFT))

#define CAM_DATA_2			(CAM_DATA__2__PC)
#define CAM_DATA_2_INTR	((uint16)((uint16)0x0001u << CAM_DATA__2__SHIFT))

#define CAM_DATA_3			(CAM_DATA__3__PC)
#define CAM_DATA_3_INTR	((uint16)((uint16)0x0001u << CAM_DATA__3__SHIFT))

#define CAM_DATA_4			(CAM_DATA__4__PC)
#define CAM_DATA_4_INTR	((uint16)((uint16)0x0001u << CAM_DATA__4__SHIFT))

#define CAM_DATA_5			(CAM_DATA__5__PC)
#define CAM_DATA_5_INTR	((uint16)((uint16)0x0001u << CAM_DATA__5__SHIFT))

#define CAM_DATA_6			(CAM_DATA__6__PC)
#define CAM_DATA_6_INTR	((uint16)((uint16)0x0001u << CAM_DATA__6__SHIFT))

#define CAM_DATA_7			(CAM_DATA__7__PC)
#define CAM_DATA_7_INTR	((uint16)((uint16)0x0001u << CAM_DATA__7__SHIFT))

#define CAM_DATA_INTR_ALL	 ((uint16)(CAM_DATA_0_INTR| CAM_DATA_1_INTR| CAM_DATA_2_INTR| CAM_DATA_3_INTR| CAM_DATA_4_INTR| CAM_DATA_5_INTR| CAM_DATA_6_INTR| CAM_DATA_7_INTR))

#endif /* End Pins CAM_DATA_ALIASES_H */


/* [] END OF FILE */
