/*******************************************************************************
* File Name: CAM_XK.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_CAM_XK_H) /* Pins CAM_XK_H */
#define CY_PINS_CAM_XK_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "CAM_XK_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 CAM_XK__PORT == 15 && ((CAM_XK__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    CAM_XK_Write(uint8 value);
void    CAM_XK_SetDriveMode(uint8 mode);
uint8   CAM_XK_ReadDataReg(void);
uint8   CAM_XK_Read(void);
void    CAM_XK_SetInterruptMode(uint16 position, uint16 mode);
uint8   CAM_XK_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the CAM_XK_SetDriveMode() function.
     *  @{
     */
        #define CAM_XK_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define CAM_XK_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define CAM_XK_DM_RES_UP          PIN_DM_RES_UP
        #define CAM_XK_DM_RES_DWN         PIN_DM_RES_DWN
        #define CAM_XK_DM_OD_LO           PIN_DM_OD_LO
        #define CAM_XK_DM_OD_HI           PIN_DM_OD_HI
        #define CAM_XK_DM_STRONG          PIN_DM_STRONG
        #define CAM_XK_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define CAM_XK_MASK               CAM_XK__MASK
#define CAM_XK_SHIFT              CAM_XK__SHIFT
#define CAM_XK_WIDTH              1u

/* Interrupt constants */
#if defined(CAM_XK__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in CAM_XK_SetInterruptMode() function.
     *  @{
     */
        #define CAM_XK_INTR_NONE      (uint16)(0x0000u)
        #define CAM_XK_INTR_RISING    (uint16)(0x0001u)
        #define CAM_XK_INTR_FALLING   (uint16)(0x0002u)
        #define CAM_XK_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define CAM_XK_INTR_MASK      (0x01u) 
#endif /* (CAM_XK__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define CAM_XK_PS                     (* (reg8 *) CAM_XK__PS)
/* Data Register */
#define CAM_XK_DR                     (* (reg8 *) CAM_XK__DR)
/* Port Number */
#define CAM_XK_PRT_NUM                (* (reg8 *) CAM_XK__PRT) 
/* Connect to Analog Globals */                                                  
#define CAM_XK_AG                     (* (reg8 *) CAM_XK__AG)                       
/* Analog MUX bux enable */
#define CAM_XK_AMUX                   (* (reg8 *) CAM_XK__AMUX) 
/* Bidirectional Enable */                                                        
#define CAM_XK_BIE                    (* (reg8 *) CAM_XK__BIE)
/* Bit-mask for Aliased Register Access */
#define CAM_XK_BIT_MASK               (* (reg8 *) CAM_XK__BIT_MASK)
/* Bypass Enable */
#define CAM_XK_BYP                    (* (reg8 *) CAM_XK__BYP)
/* Port wide control signals */                                                   
#define CAM_XK_CTL                    (* (reg8 *) CAM_XK__CTL)
/* Drive Modes */
#define CAM_XK_DM0                    (* (reg8 *) CAM_XK__DM0) 
#define CAM_XK_DM1                    (* (reg8 *) CAM_XK__DM1)
#define CAM_XK_DM2                    (* (reg8 *) CAM_XK__DM2) 
/* Input Buffer Disable Override */
#define CAM_XK_INP_DIS                (* (reg8 *) CAM_XK__INP_DIS)
/* LCD Common or Segment Drive */
#define CAM_XK_LCD_COM_SEG            (* (reg8 *) CAM_XK__LCD_COM_SEG)
/* Enable Segment LCD */
#define CAM_XK_LCD_EN                 (* (reg8 *) CAM_XK__LCD_EN)
/* Slew Rate Control */
#define CAM_XK_SLW                    (* (reg8 *) CAM_XK__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define CAM_XK_PRTDSI__CAPS_SEL       (* (reg8 *) CAM_XK__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define CAM_XK_PRTDSI__DBL_SYNC_IN    (* (reg8 *) CAM_XK__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define CAM_XK_PRTDSI__OE_SEL0        (* (reg8 *) CAM_XK__PRTDSI__OE_SEL0) 
#define CAM_XK_PRTDSI__OE_SEL1        (* (reg8 *) CAM_XK__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define CAM_XK_PRTDSI__OUT_SEL0       (* (reg8 *) CAM_XK__PRTDSI__OUT_SEL0) 
#define CAM_XK_PRTDSI__OUT_SEL1       (* (reg8 *) CAM_XK__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define CAM_XK_PRTDSI__SYNC_OUT       (* (reg8 *) CAM_XK__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(CAM_XK__SIO_CFG)
    #define CAM_XK_SIO_HYST_EN        (* (reg8 *) CAM_XK__SIO_HYST_EN)
    #define CAM_XK_SIO_REG_HIFREQ     (* (reg8 *) CAM_XK__SIO_REG_HIFREQ)
    #define CAM_XK_SIO_CFG            (* (reg8 *) CAM_XK__SIO_CFG)
    #define CAM_XK_SIO_DIFF           (* (reg8 *) CAM_XK__SIO_DIFF)
#endif /* (CAM_XK__SIO_CFG) */

/* Interrupt Registers */
#if defined(CAM_XK__INTSTAT)
    #define CAM_XK_INTSTAT            (* (reg8 *) CAM_XK__INTSTAT)
    #define CAM_XK_SNAP               (* (reg8 *) CAM_XK__SNAP)
    
	#define CAM_XK_0_INTTYPE_REG 		(* (reg8 *) CAM_XK__0__INTTYPE)
#endif /* (CAM_XK__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_CAM_XK_H */


/* [] END OF FILE */
