#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"

#include "rapiro.h"
#include "cpp_Serial.h"

#include "matrix.h"

#define LED_ON 1
#define LED_OFF 0

#define B(d) (\
	 ((((d%100000000)/10000000)?1:0)<<0) \
	|((((d%10000000)/1000000)?1:0)<<7) \
	|((((d%1000000)/100000)?1:0)<<6) \
	|((((d%100000)/10000)?1:0)<<5) \
	|((((d%10000)/1000)?1:0)<<4) \
	|((((d%1000)/100)?1:0)<<3) \
	|((((d%100)/10)?1:0)<<2) \
	|((((d%10)/1)?1:0)<<1) \
)

//0:cercle 1:smail 2,3:cry & angry
static const unsigned char
  smile_bmp[] =
  { B(800000000),
    B(800111100),
    B(801111110),
    B(811100111),
    B(811100111),
    B(801111110),
    B(800111100),
    B(800000000),
  },
  neutral_bmp[] =
  { B(800000000),
    B(800000000),
    B(800000000),
    B(800111100),
    B(801000010),
    B(810000001),
    B(800000000),
    B(800000000),
  },
  frown_a_bmp[] =
  { B(811000000),
    B(800110000),
    B(800001100),
    B(800000011),
    B(800000011),
    B(800001100),
    B(800110000),
    B(811000000),
  },
  frown_b_bmp[] =
  { B(800000011),
    B(800001100),
    B(800110000),
    B(811000000),
    B(811000000),
    B(800110000),
    B(800001100),
    B(800000011),
  };

void task_eye(intptr_t exinf)
{
	SVC_PERROR(syslog_msk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "task_eye starts (exinf = %d).", (int_t) exinf);

	matrix_l_begin(0x70);
	matrix_r_begin(0x71);

	while(1)
	{
		unsigned int data;
		rcv_dtq(DTQ_EYE, (intptr_t*)&data);
//		serial_println("task_eye/rcv_dtq %d", data);

		switch(data)
		{
		case 0:
			matrix_l_clear();
			matrix_l_drawBitmap(0, 0, smile_bmp, 8, 8, LED_ON);
			matrix_l_writeDisplay();

			matrix_r_clear();
			matrix_r_drawBitmap(0, 0, smile_bmp, 8, 8, LED_ON);
			matrix_r_writeDisplay();
			break;

		case 1:
			matrix_l_clear();
			matrix_l_drawBitmap(0, 0, neutral_bmp, 8, 8, LED_ON);
			matrix_l_writeDisplay();

			matrix_r_clear();
			matrix_r_drawBitmap(0, 0, neutral_bmp, 8, 8, LED_ON);
			matrix_r_writeDisplay();
			break;

		case 2:
			matrix_l_clear();
			matrix_l_drawBitmap(0, 0, frown_a_bmp, 8, 8, LED_ON);
			matrix_l_writeDisplay();

			matrix_r_clear();
			matrix_r_drawBitmap(0, 0, frown_b_bmp, 8, 8, LED_ON);
			matrix_r_writeDisplay();
			break;

		case 3:
			matrix_l_clear();
			matrix_l_drawBitmap(0, 0, frown_b_bmp, 8, 8, LED_ON);
			matrix_l_writeDisplay();

			matrix_r_clear();
			matrix_r_drawBitmap(0, 0, frown_a_bmp, 8, 8, LED_ON);
			matrix_r_writeDisplay();
			break;

		default: //All no light
			matrix_l_clear();
			matrix_l_writeDisplay();

			matrix_r_clear();
			matrix_r_writeDisplay();
			break;
		}
	}

	syslog(LOG_NOTICE, "task_eye ends.");
	SVC_PERROR(ext_ker());
	assert(0);
}
