#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"

#include "rapiro.h"
#include "cpp_Serial.h"

void task_main(intptr_t exinf)
{
	SVC_PERROR(syslog_msk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "task_main starts (exinf = %d).", (int_t) exinf);

	serial_begin(PORTID_SYSLOG);
	serial1_begin(PORTID_RF);
	serial2_begin(PORTID_ARD);
	serial3_begin(PORTID_BLE);

    snd_dtq(DTQ_EYE, (intptr_t)0);
    
	int n = 0;
	while(1)
	{
//		snd_dtq(DTQ_EYE, (intptr_t)n++%4);
		dly_tsk(1000);
	}

	syslog(LOG_NOTICE, "task_main ends.");
	SVC_PERROR(ext_ker());
	assert(0);
}

void isr_44100hz(intptr_t exinf)
{
	timer_isr();
}
