/*******************************************************************************
* File Name: CAM_VS.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_CAM_VS_H) /* Pins CAM_VS_H */
#define CY_PINS_CAM_VS_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "CAM_VS_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 CAM_VS__PORT == 15 && ((CAM_VS__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    CAM_VS_Write(uint8 value);
void    CAM_VS_SetDriveMode(uint8 mode);
uint8   CAM_VS_ReadDataReg(void);
uint8   CAM_VS_Read(void);
void    CAM_VS_SetInterruptMode(uint16 position, uint16 mode);
uint8   CAM_VS_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the CAM_VS_SetDriveMode() function.
     *  @{
     */
        #define CAM_VS_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define CAM_VS_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define CAM_VS_DM_RES_UP          PIN_DM_RES_UP
        #define CAM_VS_DM_RES_DWN         PIN_DM_RES_DWN
        #define CAM_VS_DM_OD_LO           PIN_DM_OD_LO
        #define CAM_VS_DM_OD_HI           PIN_DM_OD_HI
        #define CAM_VS_DM_STRONG          PIN_DM_STRONG
        #define CAM_VS_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define CAM_VS_MASK               CAM_VS__MASK
#define CAM_VS_SHIFT              CAM_VS__SHIFT
#define CAM_VS_WIDTH              1u

/* Interrupt constants */
#if defined(CAM_VS__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in CAM_VS_SetInterruptMode() function.
     *  @{
     */
        #define CAM_VS_INTR_NONE      (uint16)(0x0000u)
        #define CAM_VS_INTR_RISING    (uint16)(0x0001u)
        #define CAM_VS_INTR_FALLING   (uint16)(0x0002u)
        #define CAM_VS_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define CAM_VS_INTR_MASK      (0x01u) 
#endif /* (CAM_VS__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define CAM_VS_PS                     (* (reg8 *) CAM_VS__PS)
/* Data Register */
#define CAM_VS_DR                     (* (reg8 *) CAM_VS__DR)
/* Port Number */
#define CAM_VS_PRT_NUM                (* (reg8 *) CAM_VS__PRT) 
/* Connect to Analog Globals */                                                  
#define CAM_VS_AG                     (* (reg8 *) CAM_VS__AG)                       
/* Analog MUX bux enable */
#define CAM_VS_AMUX                   (* (reg8 *) CAM_VS__AMUX) 
/* Bidirectional Enable */                                                        
#define CAM_VS_BIE                    (* (reg8 *) CAM_VS__BIE)
/* Bit-mask for Aliased Register Access */
#define CAM_VS_BIT_MASK               (* (reg8 *) CAM_VS__BIT_MASK)
/* Bypass Enable */
#define CAM_VS_BYP                    (* (reg8 *) CAM_VS__BYP)
/* Port wide control signals */                                                   
#define CAM_VS_CTL                    (* (reg8 *) CAM_VS__CTL)
/* Drive Modes */
#define CAM_VS_DM0                    (* (reg8 *) CAM_VS__DM0) 
#define CAM_VS_DM1                    (* (reg8 *) CAM_VS__DM1)
#define CAM_VS_DM2                    (* (reg8 *) CAM_VS__DM2) 
/* Input Buffer Disable Override */
#define CAM_VS_INP_DIS                (* (reg8 *) CAM_VS__INP_DIS)
/* LCD Common or Segment Drive */
#define CAM_VS_LCD_COM_SEG            (* (reg8 *) CAM_VS__LCD_COM_SEG)
/* Enable Segment LCD */
#define CAM_VS_LCD_EN                 (* (reg8 *) CAM_VS__LCD_EN)
/* Slew Rate Control */
#define CAM_VS_SLW                    (* (reg8 *) CAM_VS__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define CAM_VS_PRTDSI__CAPS_SEL       (* (reg8 *) CAM_VS__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define CAM_VS_PRTDSI__DBL_SYNC_IN    (* (reg8 *) CAM_VS__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define CAM_VS_PRTDSI__OE_SEL0        (* (reg8 *) CAM_VS__PRTDSI__OE_SEL0) 
#define CAM_VS_PRTDSI__OE_SEL1        (* (reg8 *) CAM_VS__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define CAM_VS_PRTDSI__OUT_SEL0       (* (reg8 *) CAM_VS__PRTDSI__OUT_SEL0) 
#define CAM_VS_PRTDSI__OUT_SEL1       (* (reg8 *) CAM_VS__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define CAM_VS_PRTDSI__SYNC_OUT       (* (reg8 *) CAM_VS__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(CAM_VS__SIO_CFG)
    #define CAM_VS_SIO_HYST_EN        (* (reg8 *) CAM_VS__SIO_HYST_EN)
    #define CAM_VS_SIO_REG_HIFREQ     (* (reg8 *) CAM_VS__SIO_REG_HIFREQ)
    #define CAM_VS_SIO_CFG            (* (reg8 *) CAM_VS__SIO_CFG)
    #define CAM_VS_SIO_DIFF           (* (reg8 *) CAM_VS__SIO_DIFF)
#endif /* (CAM_VS__SIO_CFG) */

/* Interrupt Registers */
#if defined(CAM_VS__INTSTAT)
    #define CAM_VS_INTSTAT            (* (reg8 *) CAM_VS__INTSTAT)
    #define CAM_VS_SNAP               (* (reg8 *) CAM_VS__SNAP)
    
	#define CAM_VS_0_INTTYPE_REG 		(* (reg8 *) CAM_VS__0__INTTYPE)
#endif /* (CAM_VS__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_CAM_VS_H */


/* [] END OF FILE */
