/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2014 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  $Id: messagebuf.h 2589 2014-01-02 05:10:53Z ertl-hiro $
 */

/*
 *		bZ[Wobt@@\
 */

#ifndef TOPPERS_MESSAGEBUF_H
#define TOPPERS_MESSAGEBUF_H

#include "wait.h"

/*
 *  bZ[Wobt@ubN
 *
 *  ̍\̂́CEʐMIuWFNg̏ubN̋ʕ
 *  iWOBJINIBjgiIuWFNgw̌pɑĵŁC
 *  ŏ̃tB[hʂɂȂĂD
 */
typedef struct messagebuf_initialization_block {
	ATR			mbfatr;			/* bZ[Wobt@ */
	uint_t		maxmsz;			/* bZ[W̍ő咷 */
	SIZE		mbfsz;			/* bZ[Wobt@Ǘ̈̃TCY */
	void		*mbfmb;			/* bZ[Wobt@Ǘ̈̐擪Ԓn */
} MBFINIB;

/*
 *  bZ[Wobt@ǗubN
 *
 *  ̍\̂́CEʐMIuWFNg̊ǗubN̋ʕiWOBJCBj
 *  giIuWFNgw̌pɑĵŁCŏ2
 *  tB[hʂɂȂĂD
 */
typedef struct messagebuf_control_block {
	QUEUE		swait_queue;	/* bZ[Wobt@M҂L[ */
	const MBFINIB *p_mbfinib;	/* ubNւ̃|C^ */
	QUEUE		rwait_queue;	/* bZ[Wobt@M҂L[ */
	SIZE		fmbfsz;			/* 󂫗̈̃TCY */
	SIZE		head;			/* ŏ̃bZ[W̊i[ꏊ */
	SIZE		tail;			/* Ō̃bZ[W̊i[ꏊ̎ */
	uint_t		smbfcnt;		/* Ǘ̈Ɋi[Ă郁bZ[W̐ */
} MBFCB;

/*
 *  bZ[Wobt@҂ubN̒`
 *
 *  ̍\̂́CEʐMIuWFNg̑҂ubN̋ʕ
 *  iWINFO_WOBJjgiIuWFNgw̌pɑĵŁC
 *  ŏ2̃tB[hʂɂȂĂD
 *  bZ[Wobt@ւ̑M҂ƃbZ[Wobt@̎M҂ŁC
 *  ҂ubNgD
 */
typedef struct messagebuf_waiting_information {
	WINFO		winfo;			/* W̑҂ubN */
	MBFCB		*p_mbfcb;		/* ҂Ă郁bZ[Wobt@̊ǗubN */
	void		*msg;			/* MbZ[W */
	uint_t		msgsz;			/* MbZ[WTCY */
} WINFO_MBF;

/*
 *  bZ[Wobt@ID̍őlikernel_cfg.cj
 */
extern const ID	tmax_mbfid;

/*
 *  bZ[Wobt@ubÑGAikernel_cfg.cj
 */
extern const MBFINIB	mbfinib_table[];

/*
 *  bZ[Wobt@ǗubÑGAikernel_cfg.cj
 */
extern MBFCB	mbfcb_table[];

/*
 *  bZ[Wobt@ǗubN烁bZ[Wobt@IDo
 *  ߂̃}N
 */
#define	MBFID(p_mbfcb)	((ID)(((p_mbfcb) - mbfcb_table) + TMIN_MBFID))

/*
 *  bZ[Wobt@@\̏
 */
extern void	initialize_messagebuf(void);

/*
 *  bZ[Wobt@Ǘ̈ւ̃bZ[W̊i[
 */
extern bool_t	enqueue_message(MBFCB *p_mbfcb, const void *msg, uint_t msgsz);

/*
 *  bZ[Wobt@Ǘ̈悩̃bZ[W̎o
 */
extern uint_t	dequeue_message(MBFCB *p_mbfcb, void *msg);

/*
 *  bZ[Wobt@ւ̃bZ[WM
 */
extern bool_t	send_message(MBFCB *p_mbfcb, const void *msg,
											uint_t msgsz, bool_t *p_dspreq);

/*
 *  bZ[Wobt@M҂^XÑ`FbN
 */
extern bool_t	messagebuf_signal(MBFCB *p_mbfcb);

/*
 *  bZ[Wobt@̃bZ[WM
 */
extern uint_t	receive_message(MBFCB *p_mbfcb, void *msg, bool_t *p_dspreq);

/*
 *  bZ[Wobt@M҂^XN̑҂
 */
extern bool_t	(*mbfhook_dequeue_wobj)(TCB *p_tcb);
extern bool_t	messagebuf_dequeue_wobj(TCB *p_tcb);

/*
 *  bZ[Wobt@M҂^XN̗DxύX
 */
extern bool_t	(*mbfhook_change_priority)(WOBJCB *p_wobjcb);
extern bool_t	messagebuf_change_priority(WOBJCB *p_wobjcb);

#endif /* TOPPERS_MESSAGEBUF_H */
