/*******************************************************************************
* File Name: CAM_DATA.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_CAM_DATA_H) /* Pins CAM_DATA_H */
#define CY_PINS_CAM_DATA_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "CAM_DATA_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 CAM_DATA__PORT == 15 && ((CAM_DATA__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    CAM_DATA_Write(uint8 value);
void    CAM_DATA_SetDriveMode(uint8 mode);
uint8   CAM_DATA_ReadDataReg(void);
uint8   CAM_DATA_Read(void);
void    CAM_DATA_SetInterruptMode(uint16 position, uint16 mode);
uint8   CAM_DATA_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the CAM_DATA_SetDriveMode() function.
     *  @{
     */
        #define CAM_DATA_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define CAM_DATA_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define CAM_DATA_DM_RES_UP          PIN_DM_RES_UP
        #define CAM_DATA_DM_RES_DWN         PIN_DM_RES_DWN
        #define CAM_DATA_DM_OD_LO           PIN_DM_OD_LO
        #define CAM_DATA_DM_OD_HI           PIN_DM_OD_HI
        #define CAM_DATA_DM_STRONG          PIN_DM_STRONG
        #define CAM_DATA_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define CAM_DATA_MASK               CAM_DATA__MASK
#define CAM_DATA_SHIFT              CAM_DATA__SHIFT
#define CAM_DATA_WIDTH              8u

/* Interrupt constants */
#if defined(CAM_DATA__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in CAM_DATA_SetInterruptMode() function.
     *  @{
     */
        #define CAM_DATA_INTR_NONE      (uint16)(0x0000u)
        #define CAM_DATA_INTR_RISING    (uint16)(0x0001u)
        #define CAM_DATA_INTR_FALLING   (uint16)(0x0002u)
        #define CAM_DATA_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define CAM_DATA_INTR_MASK      (0x01u) 
#endif /* (CAM_DATA__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define CAM_DATA_PS                     (* (reg8 *) CAM_DATA__PS)
/* Data Register */
#define CAM_DATA_DR                     (* (reg8 *) CAM_DATA__DR)
/* Port Number */
#define CAM_DATA_PRT_NUM                (* (reg8 *) CAM_DATA__PRT) 
/* Connect to Analog Globals */                                                  
#define CAM_DATA_AG                     (* (reg8 *) CAM_DATA__AG)                       
/* Analog MUX bux enable */
#define CAM_DATA_AMUX                   (* (reg8 *) CAM_DATA__AMUX) 
/* Bidirectional Enable */                                                        
#define CAM_DATA_BIE                    (* (reg8 *) CAM_DATA__BIE)
/* Bit-mask for Aliased Register Access */
#define CAM_DATA_BIT_MASK               (* (reg8 *) CAM_DATA__BIT_MASK)
/* Bypass Enable */
#define CAM_DATA_BYP                    (* (reg8 *) CAM_DATA__BYP)
/* Port wide control signals */                                                   
#define CAM_DATA_CTL                    (* (reg8 *) CAM_DATA__CTL)
/* Drive Modes */
#define CAM_DATA_DM0                    (* (reg8 *) CAM_DATA__DM0) 
#define CAM_DATA_DM1                    (* (reg8 *) CAM_DATA__DM1)
#define CAM_DATA_DM2                    (* (reg8 *) CAM_DATA__DM2) 
/* Input Buffer Disable Override */
#define CAM_DATA_INP_DIS                (* (reg8 *) CAM_DATA__INP_DIS)
/* LCD Common or Segment Drive */
#define CAM_DATA_LCD_COM_SEG            (* (reg8 *) CAM_DATA__LCD_COM_SEG)
/* Enable Segment LCD */
#define CAM_DATA_LCD_EN                 (* (reg8 *) CAM_DATA__LCD_EN)
/* Slew Rate Control */
#define CAM_DATA_SLW                    (* (reg8 *) CAM_DATA__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define CAM_DATA_PRTDSI__CAPS_SEL       (* (reg8 *) CAM_DATA__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define CAM_DATA_PRTDSI__DBL_SYNC_IN    (* (reg8 *) CAM_DATA__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define CAM_DATA_PRTDSI__OE_SEL0        (* (reg8 *) CAM_DATA__PRTDSI__OE_SEL0) 
#define CAM_DATA_PRTDSI__OE_SEL1        (* (reg8 *) CAM_DATA__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define CAM_DATA_PRTDSI__OUT_SEL0       (* (reg8 *) CAM_DATA__PRTDSI__OUT_SEL0) 
#define CAM_DATA_PRTDSI__OUT_SEL1       (* (reg8 *) CAM_DATA__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define CAM_DATA_PRTDSI__SYNC_OUT       (* (reg8 *) CAM_DATA__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(CAM_DATA__SIO_CFG)
    #define CAM_DATA_SIO_HYST_EN        (* (reg8 *) CAM_DATA__SIO_HYST_EN)
    #define CAM_DATA_SIO_REG_HIFREQ     (* (reg8 *) CAM_DATA__SIO_REG_HIFREQ)
    #define CAM_DATA_SIO_CFG            (* (reg8 *) CAM_DATA__SIO_CFG)
    #define CAM_DATA_SIO_DIFF           (* (reg8 *) CAM_DATA__SIO_DIFF)
#endif /* (CAM_DATA__SIO_CFG) */

/* Interrupt Registers */
#if defined(CAM_DATA__INTSTAT)
    #define CAM_DATA_INTSTAT            (* (reg8 *) CAM_DATA__INTSTAT)
    #define CAM_DATA_SNAP               (* (reg8 *) CAM_DATA__SNAP)
    
	#define CAM_DATA_0_INTTYPE_REG 		(* (reg8 *) CAM_DATA__0__INTTYPE)
	#define CAM_DATA_1_INTTYPE_REG 		(* (reg8 *) CAM_DATA__1__INTTYPE)
	#define CAM_DATA_2_INTTYPE_REG 		(* (reg8 *) CAM_DATA__2__INTTYPE)
	#define CAM_DATA_3_INTTYPE_REG 		(* (reg8 *) CAM_DATA__3__INTTYPE)
	#define CAM_DATA_4_INTTYPE_REG 		(* (reg8 *) CAM_DATA__4__INTTYPE)
	#define CAM_DATA_5_INTTYPE_REG 		(* (reg8 *) CAM_DATA__5__INTTYPE)
	#define CAM_DATA_6_INTTYPE_REG 		(* (reg8 *) CAM_DATA__6__INTTYPE)
	#define CAM_DATA_7_INTTYPE_REG 		(* (reg8 *) CAM_DATA__7__INTTYPE)
#endif /* (CAM_DATA__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_CAM_DATA_H */


/* [] END OF FILE */
