/*******************************************************************************
* File Name: wen.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_wen_H) /* Pins wen_H */
#define CY_PINS_wen_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "wen_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 wen__PORT == 15 && ((wen__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    wen_Write(uint8 value);
void    wen_SetDriveMode(uint8 mode);
uint8   wen_ReadDataReg(void);
uint8   wen_Read(void);
void    wen_SetInterruptMode(uint16 position, uint16 mode);
uint8   wen_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the wen_SetDriveMode() function.
     *  @{
     */
        #define wen_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define wen_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define wen_DM_RES_UP          PIN_DM_RES_UP
        #define wen_DM_RES_DWN         PIN_DM_RES_DWN
        #define wen_DM_OD_LO           PIN_DM_OD_LO
        #define wen_DM_OD_HI           PIN_DM_OD_HI
        #define wen_DM_STRONG          PIN_DM_STRONG
        #define wen_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define wen_MASK               wen__MASK
#define wen_SHIFT              wen__SHIFT
#define wen_WIDTH              1u

/* Interrupt constants */
#if defined(wen__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in wen_SetInterruptMode() function.
     *  @{
     */
        #define wen_INTR_NONE      (uint16)(0x0000u)
        #define wen_INTR_RISING    (uint16)(0x0001u)
        #define wen_INTR_FALLING   (uint16)(0x0002u)
        #define wen_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define wen_INTR_MASK      (0x01u) 
#endif /* (wen__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define wen_PS                     (* (reg8 *) wen__PS)
/* Data Register */
#define wen_DR                     (* (reg8 *) wen__DR)
/* Port Number */
#define wen_PRT_NUM                (* (reg8 *) wen__PRT) 
/* Connect to Analog Globals */                                                  
#define wen_AG                     (* (reg8 *) wen__AG)                       
/* Analog MUX bux enable */
#define wen_AMUX                   (* (reg8 *) wen__AMUX) 
/* Bidirectional Enable */                                                        
#define wen_BIE                    (* (reg8 *) wen__BIE)
/* Bit-mask for Aliased Register Access */
#define wen_BIT_MASK               (* (reg8 *) wen__BIT_MASK)
/* Bypass Enable */
#define wen_BYP                    (* (reg8 *) wen__BYP)
/* Port wide control signals */                                                   
#define wen_CTL                    (* (reg8 *) wen__CTL)
/* Drive Modes */
#define wen_DM0                    (* (reg8 *) wen__DM0) 
#define wen_DM1                    (* (reg8 *) wen__DM1)
#define wen_DM2                    (* (reg8 *) wen__DM2) 
/* Input Buffer Disable Override */
#define wen_INP_DIS                (* (reg8 *) wen__INP_DIS)
/* LCD Common or Segment Drive */
#define wen_LCD_COM_SEG            (* (reg8 *) wen__LCD_COM_SEG)
/* Enable Segment LCD */
#define wen_LCD_EN                 (* (reg8 *) wen__LCD_EN)
/* Slew Rate Control */
#define wen_SLW                    (* (reg8 *) wen__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define wen_PRTDSI__CAPS_SEL       (* (reg8 *) wen__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define wen_PRTDSI__DBL_SYNC_IN    (* (reg8 *) wen__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define wen_PRTDSI__OE_SEL0        (* (reg8 *) wen__PRTDSI__OE_SEL0) 
#define wen_PRTDSI__OE_SEL1        (* (reg8 *) wen__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define wen_PRTDSI__OUT_SEL0       (* (reg8 *) wen__PRTDSI__OUT_SEL0) 
#define wen_PRTDSI__OUT_SEL1       (* (reg8 *) wen__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define wen_PRTDSI__SYNC_OUT       (* (reg8 *) wen__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(wen__SIO_CFG)
    #define wen_SIO_HYST_EN        (* (reg8 *) wen__SIO_HYST_EN)
    #define wen_SIO_REG_HIFREQ     (* (reg8 *) wen__SIO_REG_HIFREQ)
    #define wen_SIO_CFG            (* (reg8 *) wen__SIO_CFG)
    #define wen_SIO_DIFF           (* (reg8 *) wen__SIO_DIFF)
#endif /* (wen__SIO_CFG) */

/* Interrupt Registers */
#if defined(wen__INTSTAT)
    #define wen_INTSTAT            (* (reg8 *) wen__INTSTAT)
    #define wen_SNAP               (* (reg8 *) wen__SNAP)
    
	#define wen_0_INTTYPE_REG 		(* (reg8 *) wen__0__INTTYPE)
#endif /* (wen__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_wen_H */


/* [] END OF FILE */
