#ifdef __cplusplus
class Serial
{
	ID id;
public:
	ER_UINT begin(ID portid);
	ER_UINT begin(ID portid, uint_t ioctl);
	void print(const char *str);
	char ggetc();
	char* gets(char *buf, int len, int *size);
};
#endif

#ifdef __cplusplus
extern "C" {
#endif
	ER_UINT serial_begin(ID portid);
	ER_UINT serial_begin2(ID portid, uint_t ioctl);
	void serial_print(const char *control, ...);
	void serial_println(const char *control, ...);
	char serial_getc(void);
	char *serial_gets(char *buf, int len, int *size);

	ER_UINT serial1_begin(ID portid);
	ER_UINT serial1_begin2(ID portid, uint_t ioctl);
	void serial1_print(const char *control, ...);
	void serial1_println(const char *control, ...);
	char serial1_getc(void);
	char *serial1_gets(char *buf, int len, int *size);

	ER_UINT serial2_begin(ID portid);
	ER_UINT serial2_begin2(ID portid, uint_t ioctl);
	void serial2_print(const char *control, ...);
	void serial2_println(const char *control, ...);
	char serial2_getc(void);
	char *serial2_gets(char *buf, int len, int *size);

	ER_UINT serial3_begin(ID portid);
	ER_UINT serial3_begin2(ID portid, uint_t ioctl);
	void serial3_print(const char *control, ...);
	void serial3_println(const char *control, ...);
	char serial3_getc(void);
	char *serial3_gets(char *buf, int len, int *size);
#ifdef __cplusplus
}
#endif

/*
 *  T[rXR[̃G[̃Oo
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))
